searchNodes=[{"type":"module","title":"sqlite","doc":"sqlite3 NIF bindings for Erlang. See query/3 for the data type conversion rules. All APIs of this module provide extended error information for the shell. This information is also accessible programmatically using erl_error . try sqlite : prepare ( sqlite : open ( &quot;&quot; ) , &quot;INSERT INTO kv (key, val) VALU1ES (2, 2)&quot; ) catch Class : Reason : Stack -&gt; Formatted = erl_error : format_exception ( Class , Reason , Stack ) , io : format ( lists : flatten ( Formatted ) ) end .","ref":"sqlite.html"},{"type":"function","title":"sqlite.backup/2","doc":"Backs up the main database of the source to the destination.","ref":"sqlite.html#backup/2"},{"type":"function","title":"sqlite.backup/3","doc":"Runs a backup with the options specified Returns ok if the backup was successful, or stop if the process was requested to stop.","ref":"sqlite.html#backup/3"},{"type":"function","title":"sqlite.bind/2","doc":"Binds arguments to a prepared statement. Does not reset the statement, and throws badarg with SQL_MISUSE explanation if the statement needs to be reset first. See query/3 for types and bindings details.","ref":"sqlite.html#bind/2"},{"type":"function","title":"sqlite.clear/1","doc":"Clears bindings of the prepared statement","ref":"sqlite.html#clear/1"},{"type":"function","title":"sqlite.close/1","doc":"Closes the connection. Ensures that all prepared statements are deallocated. Forcibly stops all running backups (both source and destination). Releases the underlying database file. It is not necessary to call this function explicitly, as eventually all resources will be collected. However it might be useful if you need to unlock the database file immediately. Throws badarg if the connection is already closed.","ref":"sqlite.html#close/1"},{"type":"function","title":"sqlite.demonitor/1","doc":"EXPERIMENTAL: Stops monitoring previously monitored connection. Does not flush messages that are already in transit. This API is experimental and may change in the future.","ref":"sqlite.html#demonitor/1"},{"type":"function","title":"sqlite.describe/1","doc":"Returns column names and types for the prepared statement. SQLite uses dynamic type system. Types returned are column types specified in the CREATE TABLE statement. SQLite accepts any string as a type name, unless STRICT mode is used.","ref":"sqlite.html#describe/1"},{"type":"function","title":"sqlite.execute/2","doc":"Runs the prepared statement with new parameters bound. Resets the prepared statement, binds new parameters and steps until no more rows are available. Throws an error if at any step SQLITE_BUSY was returned, see sqlite:connect_options() for busy timeout handling. See query/3 for types and bindings details.","ref":"sqlite.html#execute/2"},{"type":"function","title":"sqlite.finish/1","doc":"Finalises the prepared statement, freeing any resources allocated The purpose of this function is to cancel statements that are executed halfway through, and it is desirable to stop execution and free all allocated resources.","ref":"sqlite.html#finish/1"},{"type":"function","title":"sqlite.format_error/2","doc":"Formats exception according to EEP-54. Used internally by the shell exception handler. Note that NIFs are not yet supported, and therefore exceptions are thrown by Erlang code. Use erl_error module to provide human-readable exception explanations.","ref":"sqlite.html#format_error/2"},{"type":"function","title":"sqlite.get_last_insert_rowid/1","doc":"Usually returns the ROWID of the most recent successful INSERT into a rowid table or virtual table on database connection. See sqlite3_last_insert_rowid in the SQLite reference.","ref":"sqlite.html#get_last_insert_rowid/1"},{"type":"function","title":"sqlite.info/1","doc":"Returns runtime statistics for the prepared statement.","ref":"sqlite.html#info/1"},{"type":"function","title":"sqlite.interrupt/1","doc":"Interrupts the query running on this connection. WARNING: this function is unsafe to use concurrently with close/1 on the same connection.","ref":"sqlite.html#interrupt/1"},{"type":"function","title":"sqlite.monitor/1","doc":"EXPERIMENTAL: monitor updates happening through the connection. This function is intended for debugging INSERT, UPDATE and DELETE operations. The API is experimental and may change in the future without prior notice. Only one process may monitor a connection. Subsequent monitor calls replace the previously set process. Upon successful completion, calling process may start receiving messages of the following format: { Ref , Op , Database , Table , RowID } Example : { # Ref &lt; 0.1954006965 . 2226257955.79689 &gt; , insert , &lt;&lt; &quot;main&quot; &gt;&gt; , &lt;&lt; &quot;table&quot; &gt;&gt; , 123 } Ref is the reference returned by monitor/1 call, Op is one of insert , update or delete operations, and RowID is the SQLite ROWID.","ref":"sqlite.html#monitor/1"},{"type":"function","title":"sqlite.open/1","doc":"Equivalent to open(FileName, \#{}) .","ref":"sqlite.html#open/1"},{"type":"function","title":"sqlite.open/2","doc":"Open the connection to a specified SQLite database.","ref":"sqlite.html#open/2"},{"type":"function","title":"sqlite.prepare/2","doc":"Equivalent to prepare(Connection, Query, \#{}) .","ref":"sqlite.html#prepare/2"},{"type":"function","title":"sqlite.prepare/3","doc":"Creates a prepared statement. Use execute/2 to run the statement. Note that close/1 invalidates all prepared statements created using the specified connection. By default, the prepared statement is not persistent. Note that if a single statement is going to be reused many times, it may prove useful to pass persistent option set to true . Running a single query/3 once is more efficient than preparing a statement, executing it once and discarding.","ref":"sqlite.html#prepare/3"},{"type":"function","title":"sqlite.query/2","doc":"Equivalent to query(Connection, Query, []) .","ref":"sqlite.html#query/2"},{"type":"function","title":"sqlite.query/3","doc":"Runs an SQL query using specified connection Query may contain placeholders, e.g. ? , ?1 , ?2 . Number of placeholders must match the length of the parameters list. However for a map-based parameters, there is no such limitation, and it is supported to bind a single column using the following syntax: \#{2 =&gt; &quot;value&quot;} . Named parameters are also supported: sqlite : query ( Conn , &quot;SELECT * FROM table WHERE key = :key&quot; , \#{ key =&gt; 1 } ) . Missing named parameters are treated as NULL. Parameters are converted to sqlite storage classed using following type mappings: binary() : accepts an Erlang binary stored as a TEXT in sqlite. See unicode module for transformations between Unicode characters list and a binary string() : accepts an Erlang string limited to iolist() type, stored as a TEXT iolist() : accepts lists supported by erlang:iolist_to_binary/1 , stored as a TEXT integer() : accepts a 64-bit signed integer (BIGNUM is not supported), stored as an INTEGER float() : accepts IEEE floating point number, stored as a FLOAT undefined : stored as NULL {blob, binary()} : accepts an Erlang binary stored as a BLOB Returns a list of database rows, or an empty list if no rows are expected to be returned (e.g. CREATE TABLE statement). By default, all TEXT fields are returned as Erlang binary() type for performance reasons. BLOB is always returned as a binary. Note that wrapping in {binary, Bin} tuple is only necessary for parameters, to tell the actual binary from an UTF8 encoded string.","ref":"sqlite.html#query/3"},{"type":"function","title":"sqlite.reset/1","doc":"Resets the prepared statement, but does not clear bindings","ref":"sqlite.html#reset/1"},{"type":"function","title":"sqlite.status/1","doc":"Returns connection statistics.","ref":"sqlite.html#status/1"},{"type":"function","title":"sqlite.step/1","doc":"Evaluates the prepared statement. Returns done when an operation has completed. May return busy , see SQLITE_BUSY return code in the sqlite reference manual.","ref":"sqlite.html#step/1"},{"type":"function","title":"sqlite.step/2","doc":"Evaluates the prepared statement. Returns either a list of rows when there are more rows available, or {done, Rows}` tuple with the list of the remaining rows. May return `{busy, Rows} , requesting the caller to handle SQL_BUSY according to sqlite recommendations.","ref":"sqlite.html#step/2"},{"type":"function","title":"sqlite.system_info/0","doc":"Returns SQLite system information (memory usage, page cache usage, allocation statistics)","ref":"sqlite.html#system_info/0"},{"type":"type","title":"sqlite.backup_options/0","doc":"Backup options from : source database name, &lt;&lt;&quot;main&quot;&gt;&gt; is the default to : destination database name, takes from value as the default stop : backup step, pages. Default is 64 progress : progress callback to invoke after finishing the next step","ref":"sqlite.html#t:backup_options/0"},{"type":"type","title":"sqlite.connect_flag/0","doc":"SQLite connections flags specification Normally used to specify an in-memory database: flags =&gt; [memory] . Example of an in-memory database shared between multiple connections: Db1 = sqlite : open ( &quot;file::mem:&quot; , \#{ flags =&gt; [ shared , memory , uri ] } ) , Db2 = sqlite : open ( &quot;file::mem:&quot; , \#{ flags =&gt; [ shared , memory , uri ] } ) , memory : enables SQLITE_OPEN_MEMORY flag uri : enables SQLITE_OPEN_URI flag shared : enables SQLITE_OPEN_SHAREDCACHE flag","ref":"sqlite.html#t:connect_flag/0"},{"type":"type","title":"sqlite.connect_options/0","doc":"SQLite connection options. mode : file open mode, the default is read_write_create flags : SQLite connection flags specification busy_timeout : specifies SQLite busy timeout. NOTE: using this setting may easily exhaust all ERTS Dirty I/O schedulers. Prefer WAL mode instead","ref":"sqlite.html#t:connect_options/0"},{"type":"type","title":"sqlite.connection/0","doc":"SQLite connection resource reference.","ref":"sqlite.html#t:connection/0"},{"type":"type","title":"sqlite.connection_status/0","doc":"SQLite connection status schema : the approximate number of bytes of heap memory used to store the schema for all databases associated with the connection (current value of SQLITE_DBSTATUS_SCHEMA_USED ) statement : the approximate number of bytes of heap and lookaside memory used by all prepared statements associated with the database connection (current value of SQLITE_DBSTATUS_STMT_USED ) deferred_fks : returns zero for the current value if and only if all foreign key constraints (deferred or immediate) have been resolved (current value of SQLITE_DBSTATUS_DEFERRED_FKS )","ref":"sqlite.html#t:connection_status/0"},{"type":"type","title":"sqlite.lookaside_memory/0","doc":"SQLite connection lookaside memory usage used : the current number of lookaside memory slots currently checked out (current value of SQLITE_DBSTATUS_LOOKASIDE_USED ) max : high watermark of SQLITE_DBSTATUS_LOOKASIDE_USED hit : number of malloc attempts that were satisfied using lookaside memory (high watermark of SQLITE_DBSTATUS_LOOKASIDE_HIT ) miss_size : the number malloc attempts that might have been satisfied using lookaside memory but failed due to the amount of memory requested being larger than the lookaside slot size (high watermark of SQLITE_DBSTATUS_LOOKASIDE_MISS_SIZE ) miss_full : the number malloc attempts that might have been satisfied using lookaside memory but failed due to all lookaside memory already being in use (high watermark of SQLITE_DBSTATUS_LOOKASIDE_MISS_FULL )","ref":"sqlite.html#t:lookaside_memory/0"},{"type":"type","title":"sqlite.pager_cache_memory/0","doc":"SQLite connection pager cache memory usage used : the approximate number of bytes of heap memory used by all pager caches associated with the database connection (current value of SQLITE_DBSTATUS_CACHE_USED ) shared : current value of SQLITE_DBSTATUS_CACHE_USED_SHARED hit : the number of pager cache hits that have occurred (current value of SQLITE_DBSTATUS_CACHE_HIT ) miss : the number of pager cache misses that have occurred (current value of SQLITE_DBSTATUS_CACHE_MISS) write : the number of dirty cache entries that have been written to disk (current value of SQLITE_DBSTATUS_CACHE_WRITE ) spill : the number of dirty cache entries that have been written to disk in the middle of a transaction due to the page cache overflowing. Both values of SQLITE_DBSTATUS_CACHE_SPILL","ref":"sqlite.html#t:pager_cache_memory/0"},{"type":"type","title":"sqlite.parameter/0","doc":"Erlang type allowed to be used in SQLite bindings.","ref":"sqlite.html#t:parameter/0"},{"type":"type","title":"sqlite.parameters/0","doc":"Positional and named parameters. A list of parameters must match the expected number of parameters. A map of parameters may be used to define named parameters, or assign specific columns. When map key is an integer, it is treated as a column index.","ref":"sqlite.html#t:parameters/0"},{"type":"type","title":"sqlite.prepare_options/0","doc":"Prepared statement creation flags persistent : The SQLITE_PREPARE_PERSISTENT flag is a hint to the query planner that the prepared statement will be retained for a long time and probably reused many times no_vtab : The SQLITE_PREPARE_NO_VTAB flag causes the SQL compiler to return an error (error code SQLITE_ERROR) if the statement uses any virtual tables","ref":"sqlite.html#t:prepare_options/0"},{"type":"type","title":"sqlite.prepared_statement/0","doc":"Prepared statement reference.","ref":"sqlite.html#t:prepared_statement/0"},{"type":"type","title":"sqlite.progress_callback/0","doc":"Backup progress callback. Must return ok for backup to continue, {ok, Steps}` to change the steps amount. Return `stop to stop the backup process. Throwing an exception also stops the process.","ref":"sqlite.html#t:progress_callback/0"},{"type":"type","title":"sqlite.row/0","doc":"","ref":"sqlite.html#t:row/0"},{"type":"type","title":"sqlite.statement_info/0","doc":"Prepared statement statistics Performance counters for SQLite statement. See sqlite3_stmt_status function in SQLite reference.","ref":"sqlite.html#t:statement_info/0"},{"type":"type","title":"sqlite.system_info/0","doc":"Status information about the performance of SQLite See sqlite3_status in the SQLite reference for more details about exported statistics.","ref":"sqlite.html#t:system_info/0"},{"type":"extras","title":"Overview","doc":"sqlite3 NIF bindings for Erlang. See sqlite:query/3 for the data type conversion details. Current version assumes UTF8 encoding for all TEXT columns. All functions that may affect scheduling run in the dirty I/O scheduler. Keep an eye on the dirty scheduler utilisation, and bump the number when necessary (using +SDio argument).","ref":"readme.html"},{"type":"extras","title":"Overview - Build","doc":"Use rebar3 compile to build the application using included SQLite3 amalgamation. Specify USE_SYSTEM_SQLITE environment variable to build against sqlite version provided by the system (tested with sqlite 3.37.2 and newer). sqlite3 amalgamation build flags are accepted through CFLAGS , e.g. CFLAGS=&quot;-DSQLITE_USE_URI&quot; rebar3 compile . For a debug build, specify DEBUG=1 environment variable. Both NIF bindings and sqlite amalgamation files are affected by this flag. Remember to run rebar3 clean when changing build flavour. Requires OTP 24 and above (older versions do not support extended error specification per EEP-54). Find a list of supported Operating Systems in the corresponding section.","ref":"readme.html#build"},{"type":"extras","title":"Overview - Quick start","doc":"The easiest way to try it out is to run rebar3 shell within the cloned project folder. 1 &gt; Conn = sqlite :open ( &quot;mem&quot; , \#{flags =&gt; [memory]}). %% open an in-memory database # Ref &lt; 0.1238832725 . 87949353.240438 &gt; 2 &gt; sqlite :query ( Conn , &quot;CREATE TABLE kv (key INTEGER PRIMARY KEY AUTOINCREMENT, val INTEGER)&quot; ) . [ ] 3 &gt; Prepared = sqlite :prepare ( Conn , &quot;INSERT INTO kv (val) VALUES (?1)&quot; , \#{persistent =&gt; true}). # Ref &lt; 0.1238832725 . 87949353.240439 &gt; 4 &gt; [ sqlite :execute ( Prepared , [ Seq ] ) || Seq &lt;- lists :seq ( 1 , 100 ) ] . [ [ ] , [ ] , [ ] , [ ] , [ ] , [ ] | ... ] 5 &gt; sqlite :query ( Conn , &quot;SELECT * FROM kv&quot; ) . [ { 1 , 1 } , { 2 , 2 } , &lt; ... &gt;","ref":"readme.html#quick-start"},{"type":"extras","title":"Overview - Configuration","doc":"Due to significant performance difference observed for in-memory databases, there is an option to fall back to sqlite built-in memory allocation functions. Set enif_malloc configuration variable to false (the default is true ) to let sqlite use built-in allocators instead of the recommended enif_alloc . As a consequence, memory allocated by sqlite3 will no longer be visible via usual Erlang functions. For example erlang:memory/1 won't be able to report sqlite3 allocations). Use this option only when you need that last bit of performance.","ref":"readme.html#configuration"},{"type":"extras","title":"Overview - Profiling with Linux perf","doc":"Ensure ERTS with frame pointers enabled ( frmptr flavour) is available. export ERL_FLAGS=&quot;+JPperf true -emu_type frmptr&quot; export CFLAGS=&quot;-fno-omit-frame-pointer&quot;&quot; # run the benchmark test case rebar3 ct --suite sqlite_QUITE --case benchmark_prepared # take 10 second of perf profiling perf record -g -p `pidof rebar3` -F 500 -- sleep 10 # convert to a flame graph perf script | ./stackcollapse-perf.pl &gt; out.perf-folded ./flamegraph.pl out.perf-folded &gt; perf.svg","ref":"readme.html#profiling-with-linux-perf"},{"type":"extras","title":"Overview - Operating system support","doc":"Initial version has been tested on Linux (Ubuntu), Mac OS, FreeBSD 13 and Windows 10. Mac OS If you see Apple Silicon (ARM64) build failing with this diagnostic: Undefined symbols for architecture arm64 : &quot;_enif_alloc&quot; , referenced from : Clear the LDFLAGS variable with unset LDFLAGS and try again. Windows Windows build, with rebar3 as an escript, assuming Ericsson official installation into C:\\Program Files\\Erlang OTP . If you have it elsewhere, set ERTS_INCLUDE_DIR environment variable appropriately, to the usr/include subfolder of your installation. Build requires x64 Native Tools Command Prompt . Tested with VS 2022. Ensure to see the slogan: [vcvarsall.bat] Environment initialized for: 'x64' # set up PATH to escript/erl set PATH = % PATH % ; C : \\ Program Files \\ Erlang OTP \\ bin # download or build rebar3 (assuming it is now in the current directory) # use rebar3 to build sqlite and run Common Test escript . exe rebar3 ct","ref":"readme.html#operating-system-support"},{"type":"extras","title":"Overview - Missing Features for 1.0","doc":"performance: use &quot;trylock&quot; and then reschedule instead of dirty NIF from the beginning performance: transparently handle BUSY and LOCKED instead of busy wait in dirty scheduler asynchronous APIs (using message exchange, e.g. for query and execute ) diagnostic routines to enumerate prepared statements/statements running","ref":"readme.html#missing-features-for-1-0"},{"type":"extras","title":"Overview - Features beyond 1.0","doc":"These features will not make it into 1.0, but are useful and may be implemented in the following releases: non-experimental sqlite hooks support (commit, preupdate, rollback, update, wal) sqlite snapshot, vfs, blob and serialization support improved performance for concurrent access to the same connection/statement, running on a normal scheduler and yielding support for atom() and map() type conversion named parameters with '@' and Tcl syntax","ref":"readme.html#features-beyond-1-0"},{"type":"extras","title":"License","doc":"Copyright (c) 2023 Maxim Fedorov maximfca@gmail.com All rights reserved. Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met: Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission. NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.","ref":"license.html"}]